# -*- coding: UTF-8 -*-
import json


def get_tags():
    return ['2', '2.6']


def run_task(runcontext):
    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params, "chdir", None)
    runcontext.set_mod_params_instance(ansible_params, "executable", None)

    module = runcontext.get_module_file("shell.py")
    rc, out = run_audit(runcontext, ansible_params, module)
    return rc, out


def run_audit(runcontext, ansible_params, module):
    curtemplate = runcontext.get_template()
    ret_code = -1
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"

    tmp_vars["checkresult1"] = "pass"
    tmp_vars["scancommand1"] = r'''cat /etc/ssh/sshd_config 2>/dev/null | grep -v '^\s*#' | grep -i '^\s*Ciphers\s*' | awk -F' ' '{print $2}' '''
    tmp_vars["systemvalue1"] = ""

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand1"])
    arc1, astdout1, astderr1 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc1, astdout1, astderr1)
    runcontext.sleep()

    if arc1 != 0:
        return (-2, "Failed to invoke module: %s." % astdout1)
    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    astderr1 = resultjson1["stderr"]
    tmp_vars["systemvalue1"] = astdout1

    ciphers_list = ['aes256-ctr', 'aes192-ctr', 'aes128-ctr']
    astdout = astdout1.split(",")
    for out in astdout:
        if out not in ciphers_list:
            tmp_vars["checkresult1"] = "failed"
            break

    if tmp_vars["checkresult1"] == "pass":
        ret_code = 0
        tmp_vars["policyresult"] = "pass"

    rc, out = curtemplate.render(runcontext.get_template_file('t_2_6.j2'), **tmp_vars)

    if rc == False:
        return (-2, "Failed to render template.%s" % out)

    return ret_code, out
